/*
 * Created on 2005/02/23
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.audio.splitter;



import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jpn.xucker.commons.audio.AudioUtils;


import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.UnsupportedAudioFileException;

/**
 * 
 *
 */
public class JavaSoundWaveAudioCutter implements AudioCutter{
public static Log log=LogFactory.getLog(JavaSoundWaveAudioCutter.class);
private boolean useBuffer;


public JavaSoundWaveAudioCutter(){

}

public boolean isUseBuffer() {
    return useBuffer;
}

public void setUseBuffer(boolean useBuffer) {
    this.useBuffer = useBuffer;
}


private void insplit(long startmillisecond, long endmillisecond, File inputFile, OutputStream output) throws UnsupportedAudioFileException, IOException {
    AudioInputStream audioInputStream=null;
   
        audioInputStream=AudioSystem.getAudioInputStream(inputFile);
        //AudioInputStream inputStream =
        // AudioSystem.getAudioInputStream(audioFile);
         AudioFormat format =audioInputStream.getFormat();
         
         long startByte=AudioUtils.countByteAt(format,startmillisecond);
         long endByte=AudioUtils.countByteAt(format,endmillisecond);
         long playByte=endByte-startByte;
         
         if(log.isTraceEnabled()){
         log.trace("start:"+startByte);
         log.trace("end:"+endByte);
         log.trace("play:"+playByte);
         log.trace("bit:"+format.getChannels()*(format.getSampleSizeInBits()/8)*format.getFrameRate());
         
         }
         
         audioInputStream.skip(startByte);
         
         
         
         
          int readBytes = 0;
          byte[] bytedata = new byte[1028];
          long readedByte=0;
          while (readBytes != -1) {
              if(stopper!=null && stopper.isStopped()==true){
                  audioInputStream.close();
                  return;
              }
           readBytes = audioInputStream.read(bytedata, 0, bytedata.length);
            if (readBytes >= 0) {
                
                if(readedByte+readBytes<playByte){
                    output.write(bytedata,0,readBytes);
                }else{
                    output.write(bytedata, 0, Math.min((int)(playByte-readedByte),readBytes));
                break;
                }
                readedByte+=readBytes;
            }
          }
          
          audioInputStream.close();
          
   
        
       
}

    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.audio.splitter.AudioSplitter#split(long, long, java.io.InputStream, java.io.OutputStream)
     */
    private void insplit(long startmillisecond, long endmillisecond, InputStream input, OutputStream output) throws UnsupportedAudioFileException, IOException {
        AudioInputStream audioInputStream=null;
       
            audioInputStream=AudioSystem.getAudioInputStream(input);
            //AudioInputStream inputStream =
            // AudioSystem.getAudioInputStream(audioFile);
             AudioFormat format =audioInputStream.getFormat();
             
             long startByte=AudioUtils.countByteAt(format,startmillisecond);
             long endByte=AudioUtils.countByteAt(format,endmillisecond);
             long playByte=endByte-startByte;
             
             if(log.isTraceEnabled()){
             log.trace("start:"+startByte);
             log.trace("end:"+endByte);
             log.trace("play:"+playByte);
             log.trace("bit:"+format.getChannels()*format.getSampleSizeInBits()*format.getFrameRate());
             }
             
             audioInputStream.skip(startByte);
             
             
             
             
              int readBytes = 0;
              byte[] bytedata = new byte[1028];
              long readedByte=0;
              while (readBytes != -1) {
                  if(stopper!=null && stopper.isStopped()==true){
                      audioInputStream.close();
                      return;
                  }
               readBytes = audioInputStream.read(bytedata, 0, bytedata.length);
                if (readBytes >= 0) {
                    if(readedByte+readBytes<playByte){
                        output.write(bytedata,0,readBytes);
                    }else{
                        output.write(bytedata, 0, Math.min((int)(playByte-readedByte),readBytes));
                    break;
                    }
                    readedByte+=readBytes;
                }
              }
              
              audioInputStream.close();
              
       
            
           
    }
    /*
    public void split(long startmillisecond, long endmillisecond, InputStream input, OutputStream output){
        try {
            insplit(startmillisecond,endmillisecond,input,output);
            output.close();
        } catch (UnsupportedAudioFileException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }*/

    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.audio.splitter.AudioSplitter#split(long, long, java.io.File, java.io.File)
     */
    
    private void splitFileBuffer(long startmillisecond, long endmillisecond, File inputFile, File outputFile) throws IOException {
        ByteArrayOutputStream bout=new ByteArrayOutputStream();
        try {
            InputStream input = new FileInputStream(inputFile);
            
           
                 
            insplit(startmillisecond,endmillisecond,inputFile,bout);
            bout.close();
            
            AudioInputStream audioInputStream=AudioSystem.getAudioInputStream(inputFile);
            AudioFormat audioFormat =audioInputStream.getFormat();
            
            AudioInputStream clipInput=new AudioInputStream(new ByteArrayInputStream(bout.toByteArray()),audioFormat,bout.size()/4);
            
             
            FileOutputStream output=new FileOutputStream(outputFile);
            int writtenBytes=-1;
            
            
                writtenBytes=AudioSystem.write(
     			        clipInput
     			        ,AudioFileFormat.Type.WAVE,
     				output);
            
            
            log.trace("write:"+writtenBytes);
             
            
            
            clipInput.close();
             
            output.close();
        } catch (UnsupportedAudioFileException e) {
            // TODO Auto-generated catch block
            log.fatal("",e);
        } 
    }
    public void cut(File inputFile, long startmillisecond, long endmillisecond, File outputFile) throws IOException{
        if(log.isTraceEnabled()){
            log.trace(startmillisecond+","+endmillisecond+","+inputFile.getAbsolutePath()+","+outputFile.getAbsolutePath());
                
        }
        if(useBuffer){
            splitFileBuffer(startmillisecond,endmillisecond,inputFile,outputFile);
        }else{
            splitFileTmpFile(startmillisecond,endmillisecond,inputFile,outputFile);
        }
    }
    
    public void cut(File inputFile, long startmillisecond[], long endmillisecond[], File outputFile[]) throws IOException{
        for(int i=0;i<startmillisecond.length;i++){
            if(stopper!=null && stopper.isStopped()==true){
                return;
            }
        if(log.isTraceEnabled()){
            log.trace(startmillisecond[i]+","+endmillisecond[i]+","+inputFile.getAbsolutePath()+","+outputFile[i].getAbsolutePath());
                
        }
        if(useBuffer){
            splitFileBuffer(startmillisecond[i],endmillisecond[i],inputFile,outputFile[i]);
        }else{
            splitFileTmpFile(startmillisecond[i],endmillisecond[i],inputFile,outputFile[i]);
        }
        }
    }
    
    private void splitFileTmpFile(long startmillisecond, long endmillisecond, File inputFile, File outputFile) throws IOException{
      
        try {
         
            
            
            File tmpFile=File.createTempFile("wavsplitter",".wav");
            log.trace("create tmp:"+tmpFile.getAbsolutePath());
            
            FileOutputStream fout=new FileOutputStream(tmpFile);
            InputStream input = new FileInputStream(inputFile);
            
            
            insplit(startmillisecond,endmillisecond,inputFile,fout);
            fout.close();
            
            
            
            AudioInputStream audioInputStream=AudioSystem.getAudioInputStream(inputFile);
            AudioFormat audioFormat =audioInputStream.getFormat();
            
            
            
            AudioInputStream clipInput=new AudioInputStream(new FileInputStream(tmpFile),audioFormat,tmpFile.length()/4);
            
             
            FileOutputStream output=new FileOutputStream(outputFile);
            
            int writtenBytes=-1;
            
            
                writtenBytes=AudioSystem.write(
     			        clipInput
     			        ,AudioFileFormat.Type.WAVE,
     				output);
            
            
            log.trace("write:"+writtenBytes);
            
            
            clipInput.close();
             
            output.close();
            boolean result=tmpFile.delete();
            log.trace("delte tmp:"+result);
        }  catch (UnsupportedAudioFileException e) {
            log.fatal("",e);
        } 
        
    }

    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.audio.splitter.AudioCutter#setStopper(org.jpn.xucker.commons.audio.splitter.StopperOfMP3Cutter)
     */
    StopperOfAudioCutter stopper;
    public void setStopper(StopperOfAudioCutter stopper) {
        this.stopper=stopper;
    }
}
