/*
 * Created on 2004/10/03
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.audio.word;

import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.UnsupportedAudioFileException;

import org.jpn.xucker.commons.audio.InputStreamAudioPlayer;

/**
 * 
 *
 */
public class ZipFileWordPlayer extends AbstractWordPlayer{
   
    public ZipFileWordPlayer(String path){
        this.path=path;
    }
    
    public ZipFileWordPlayer(String path,InputStreamAudioPlayer player){
        this.player=player;
        this.path=path;
    }
    
public InputStreamAudioPlayer getPlayer() {
    return player;
}
public void setPlayer(InputStreamAudioPlayer player) {
    this.player = player;
}
private InputStreamAudioPlayer player;
    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.audio.sp.WordAudioPlayer#play(java.lang.String)
     */
    public void play(String word) {
      
            ZipFile zipFile;
            try {
                zipFile = new ZipFile(path);
                ZipEntry entry=getZipEntry(word);
                player.play(zipFile.getInputStream(entry));
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } 
            
        
    }
    

    protected String path;
    public void setZipFilePath(String path){
        this.path=path;
    }
    
    public static final int BOTH=0;
    public static final int ALPHABET=1;
    public static final int PLAIN=2;
    public int getMode() {
        return mode;
    }
    public void setMode(int mode) {
        this.mode = mode;
    }
    private int mode;
    
    protected ZipEntry getZipEntry(String word){
        ZipFile zipFile;
        ZipEntry entry=null;
        try {
            zipFile = new ZipFile(path);
            
            if(mode==BOTH || mode==ALPHABET){
                String sub=""+word.charAt(0);
                entry=zipFile.getEntry(sub.toLowerCase()+"/"+word.toLowerCase()+".wav");
            }
        
        if(entry==null){
         if(mode==BOTH || mode==PLAIN){
             entry=zipFile.getEntry(word.toLowerCase()+".wav");
         }
        }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        
     
    
        
        
     
        
        return entry;
    }

    
    public boolean exist(String word) {
       return getZipEntry(word)!=null;
    }
    
}
