/*
 * Created on 2004/08/07
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.swt.series.fls;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.jpn.xucker.commons.swt.series.ResultData;
import org.jpn.xucker.commons.swt.ui.CopyTable;
import org.jpn.xucker.commons.swt.ui.FileListComposite;

import java.io.File;

public abstract class FileListStandard implements SelectionListener{
	/**
	 * @param shell
	 */
protected FileListComposite fileListCanvas;
protected Button execButton;
protected Table resultTable;
protected double version=0.1;



protected Shell shell;

protected String[] resultColumnText={"label1","label2"};
protected int[] resultColumnWidth={100,100};

	protected CopyTable copyTable;
    protected String HOMEPAGE_URL="http://www.xucker.jpn.org/product/";
    protected String APP_NAME="App";
    protected String ICON_RESOURCE="org/jpn/xucker/commons/resource/icon.png";
    protected String EXEC_LABEL="exec";	
    
    
    protected Menu  menuBar;
    protected MenuItem cascademenu1;
    protected MenuItem file;
    protected MenuItem folder;
    protected MenuItem exit;
    protected MenuItem cascademenu6;
    protected MenuItem copy;
   
    protected MenuItem cascademenu3;
    protected MenuItem versionMenu;
    protected MenuItem homepage;
    
    protected Group optionGroup;
   // protected RowData fileListTableRowData;
	public FileListStandard(Shell shell) {
	    this.shell=shell;
	    beforeConstract();
	    menuBar=new Menu(shell,SWT.BAR);
	    createMenu(shell,menuBar);
	    shell.setMenuBar(menuBar);
	    
	   
	    Image icon= new Image(shell.getDisplay(), this.getClass()
                .getClassLoader().getResourceAsStream(
                ICON_RESOURCE));
	    
	    shell.setImage(icon);


		
		shell.setText(APP_NAME+" v"+version);
		shell.setBounds(0,0,500,405);
		//RowLayout layout=new RowLayout();
		shell.setLayout(new GridLayout(1,false));
		
		//Label label=new Label(shell,SWT.NULL);
		//label.setImage(fileImage);
		fileListCanvas=new FileListComposite(shell,SWT.NULL);
		fileListCanvas.setVisibleFilterExtensions(false);
		
		GridData filelist_data=new GridData(GridData.FILL_HORIZONTAL);
		filelist_data.heightHint=120;
		fileListCanvas.setLayoutData(filelist_data);
		//fileListCanvas.setEditableExtensions(false);

//fileListTableRowData = new RowData();
//fileListTableRowData.width=470;
//fileListTableRowData.height=135;
//fileListCanvas.setLayoutData(fileListTableRowData);

optionGroup=new Group(shell,SWT.NULL);
//optionGroup.setLayout(new RowLayout());
optionGroup.setText("IvV");
createOptionUI(optionGroup);
if(optionGroup.getChildren().length==0){
    optionGroup.dispose();
}
execButton=new Button(shell,SWT.NULL);
execButton.setText(EXEC_LABEL);
execButton.addSelectionListener(this);
GridData button1_data=new GridData(GridData.FILL_HORIZONTAL);
button1_data.heightHint=60;
execButton.setLayoutData(button1_data);
//RowData button1_data=new RowData();
//execButton.setLayoutData(button1_data);
//button1_data.width=485;
//button1_data.height=30;
//Label label2=new Label(shell,SWT.NULL);
//label2.setImage(resultImage);
copyTable=new CopyTable(shell,SWT.HIDE_SELECTION);
resultTable=copyTable.getTable();
resultTable.setHeaderVisible(true);
resultTable.setLinesVisible(true);
resultTable.addSelectionListener(this);

GridData table1_data=new GridData(GridData.FILL_BOTH);
table1_data.heightHint=120;
resultTable.setLayoutData(table1_data);

//RowData table1_data=new RowData();
//table1_data.width=470;
//table1_data.height=140;
//resultTable.setLayoutData(table1_data);
if(resultColumnText.length!=resultColumnWidth.length){
    throw new RuntimeException("column name and width differ");
}
for(int i=0;i<resultColumnText.length;i++){
    TableColumn table1_column =new TableColumn(resultTable,SWT.NONE);
    table1_column.setText(resultColumnText[i]);
    table1_column.setWidth(resultColumnWidth[i]);
}

afterConstract();

	}

	/**
     * @param optionGroup2
     */
    protected abstract void createOptionUI(Group optionGroup2);

    /**
     * 
     */
    abstract protected void afterConstract();
    abstract protected void beforeConstract();
    /**
     * @param shell2
     * @param menuBar
     */
    protected  void createMenu(Shell shell, Menu menuBar){

        Menu cascademenu1_menu=new Menu(shell,SWT.DROP_DOWN);
        cascademenu1=new MenuItem(menuBar,SWT.CASCADE);
        cascademenu1.setText("t@C");
        cascademenu1.setMenu(cascademenu1_menu);
//        t@C̒ǉ
        file=new MenuItem(cascademenu1_menu,SWT.PUSH);
        file.setText("t@C̒ǉ");
        file.addSelectionListener(this);
//        tH_[̒ǉ
        folder=new MenuItem(cascademenu1_menu,SWT.PUSH);
        folder.setText("tH_[̒ǉ");
        folder.addSelectionListener(this);
        MenuItem separatemenu4=new MenuItem(cascademenu1_menu,SWT.SEPARATOR);
//        I
        exit=new MenuItem(cascademenu1_menu,SWT.PUSH);
        exit.setText("I");
        exit.addSelectionListener(this);
        Menu cascademenu6_menu=new Menu(menuBar);
        cascademenu6=new MenuItem(menuBar,SWT.CASCADE);
        cascademenu6.setText("ҏW");
        cascademenu6.setMenu(cascademenu6_menu);
//        Rs[
        copy=new MenuItem(cascademenu6_menu,SWT.PUSH);
        copy.setText("Rs[");
        copy.addSelectionListener(this);


        Menu cascademenu3_menu=new Menu(shell,SWT.DROP_DOWN);
        cascademenu3=new MenuItem(menuBar,SWT.CASCADE);
        cascademenu3.setText("wv");
        cascademenu3.setMenu(cascademenu3_menu);
//        t@C̒ǉ
        versionMenu=new MenuItem(cascademenu3_menu,SWT.PUSH);
        versionMenu.setText("o[W");
        versionMenu.addSelectionListener(this);

        homepage=new MenuItem(cascademenu3_menu,SWT.PUSH);
        homepage.setText("z[y[W");
        homepage.addSelectionListener(this);
        	}

    

    /*
    public static void main(String[] args) {
	    
		Display display=new Display();
		Shell shell=new Shell(display,SWT.CLOSE|SWT.MIN);
		
		
		FileListStandard main=new FileListStandard(shell);
		
		
		shell.open();
		
		while(!shell.isDisposed()){			
			if (!display.readAndDispatch ()){
					display.sleep ();
				  }
		}
		display.dispose();
	    
	}
	*/
	
	public void widgetSelected(SelectionEvent event) {
	Object target=event.getSource();
   	if(target==null){
   		//maybe not happen.
   		System.out.println("target==null");
   		}
   	//null1
else if(target==fileListCanvas){
do_filelist1();
  }
//null1
else if(target==execButton){
do_executeButton();
  }
//null1
else if(target==resultTable){
do_table1();
  }

   	else if(target==file){
   	 this.execAddFile();
   	   }
//   	 tH_[̒ǉ
   	 else if(target==folder){
   	  this.execAddFolder();
   	   }
//   	 I
   	 else if(target==exit){
   	  this.execExit();
   	   }
//   	 Rs[
   	 else if(target==copy){
   	  this.execCopy();
   	   }
   	 else if(target==versionMenu){
   	  this.execVersion();
   	       }
   	 else if(target==homepage){
   	  this.execHomepage();
   	       }

   	 otherWidgetSelected(event);

    }
    
    /**
     * @param event
     */
    protected void otherWidgetSelected(SelectionEvent event) {
        // if it's needed,you should overwrite
        
    }

    /**
     * 
     */

	
	//null1
public void do_filelist1(){
System.out.println("filelist1");
  }
//null1
public void do_executeButton(){
resultTable.removeAll();
execButton.setEnabled(false);
beforeExecute();
String[] fileList=fileListCanvas.getFiles();
for(int i=0;i<fileList.length;i++){
    execFile(new File(fileList[i]));
}
afterExecute();
execButton.setEnabled(true);
  }
/**
 * 
 */
protected void beforeExecute() {
    // TODO Auto-generated method stub
    
}

/**
 * 
 */
protected void afterExecute() {
    // TODO Auto-generated method stub
    
}

/**
 * @param file
 */

public abstract void execFile(File file);

//null1
public void do_table1(){

  }

public void execExit(){
    shell.close();
}

public void execAddFile(){
    fileListCanvas.execAddFile();
}

public void execAddFolder(){
    fileListCanvas.execAddFolder();
}

public void execCopy(){
    copyTable.execCopy();
}
	
public void addResult(ResultData data){
    TableItem item=new TableItem(resultTable,SWT.NULL);
    if(data.getColor()!=null){
        item.setForeground(data.getColor());
    }
    String values[]=new String[resultColumnText.length];
    for(int i=0;i<values.length;i++){
        values[i]=data.getValue(resultColumnText[i]);
    }
    parseValues(item,values);
   
    
}

/**
 * @param item
 * @param values
 */
protected void parseValues(TableItem item, String[] values) {
    // TODO Auto-generated method stub
    item.setText(values);
}

/**
 * @param values
 */


public void execHomepage(){
    Program program=Program.findProgram("html");
    if(program!=null){
        program.execute(HOMEPAGE_URL);
    }
   
}
public void execVersion() {
    MessageBox box = new MessageBox(shell, SWT.OK | SWT.ICON_INFORMATION);
    box.setMessage(APP_NAME+" v" + version + "\r\n\r\n"
            + "License CPL or Apache2.0\r\n (c)AbL[  2004\r\n"
            + HOMEPAGE_URL);

    //int result=box.open();
    //never use result int,for PMD
    box.open();
}

/* (non-Javadoc)
 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
 */
public void widgetDefaultSelected(SelectionEvent arg0) {
    
}


    public FileListComposite getFileListCanvas() {
        return fileListCanvas;
    }
    public void setFileListCanvas(FileListComposite fileListCanvas) {
        this.fileListCanvas = fileListCanvas;
    }
}

