package org.jpn.xucker.commons.swt.ui;

/*
 * Created on 2004/06/27
 * 
 * Author aki@www.xucker.jpn.org License Apache2.0 or Common Public License
 */



import java.util.List;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.DropTargetListener;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.jpn.xucker.commons.util.Messages;
import org.jpn.xucker.commons.util.WildCard;

import java.io.File;



public class FileListComposite  extends Composite implements KeyListener,MouseListener,SelectionListener {
    /**
     * @param shell
     */
    private Menu menu1;

    private MenuItem addfile;

    private MenuItem addfolder;

    private MenuItem separatemenu3;

    private MenuItem deletefile;
    private MenuItem deleteAll;
    
    private Table table;
    private Image fileIcon;
    private Image folderIcon;
    //private String[] fileExtension;
    
    
    private boolean addsameFile;
    
    
    Text filterExtensionsText;
    private boolean visibleFilterExtensions=true;
    
    private boolean editableExtensions=true;
    
    GridData gridData_filterExtensionsLabel;
    GridData gridData_filterExtensionsText;
    
    public void setVisibleFilterExtensions(boolean bool){
      
            
     filterExtensionsLabel.setVisible(bool);
     filterExtensionsText.setVisible(bool);
     visibleFilterExtensions=bool;
        
     if(bool){
        // gridData_filterExtensionsLabel=new GridData(GridData.FILL_HORIZONTAL);
         gridData_filterExtensionsLabel.verticalSpan=1;
         //filterExtensionsLabel.setLayoutData(gridData_filterExtensionsLabel);
         
         //gridData_filterExtensionsText=new GridData(GridData.FILL_HORIZONTAL);
         
         gridData_filterExtensionsText.verticalSpan=1;
         //filterExtensionsText.setLayoutData(gridData_filterExtensionsText);
     }else{
         gridData_filterExtensionsLabel.verticalSpan=0;
         
         
        
         gridData_filterExtensionsText.verticalSpan=0;
     }
     
     
     layout();   
        
    }
    
    

    public boolean isVisibleFilterExtensions(){
        return visibleFilterExtensions;
    }
    
    public String getFilterExtensionsText(){
        return filterExtensionsText.getText();
    }
    
    public void setFilterExtensionsText(String text){
         filterExtensionsText.setText(text);
    }
    
    
    public FileListComposite(Composite parent, int layout) {
        super(parent,layout);
        
        GridLayout gridLayout=new GridLayout(2,true);
        this.setLayout(gridLayout);
        //this.setLayout(new RowLayout());
        
        filterExtensionsLabel = new Label(this,SWT.NULL);
        gridData_filterExtensionsLabel=new GridData(GridData.FILL_HORIZONTAL);
        filterExtensionsLabel.setLayoutData(gridData_filterExtensionsLabel);
        filterExtensionsLabel.setText("FileterExtensions");
        
        filterExtensionsText=new Text(this,SWT.NULL);
        gridData_filterExtensionsText=new GridData(GridData.FILL_HORIZONTAL);
        filterExtensionsText.setLayoutData(gridData_filterExtensionsText);
        
        fileIcon = new Image(Display.getCurrent(), FileListComposite.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/commons/resource/file.png")); //$NON-NLS-1$
        folderIcon = new Image(Display.getCurrent(), FileListComposite.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/commons/resource/folder.png")); //$NON-NLS-1$
        
        table=new Table(this,layout);
        
        GridData data=new GridData(GridData.FILL_BOTH);
        data.horizontalSpan=2;
        data.grabExcessHorizontalSpace=true;
        data.grabExcessVerticalSpace=true;
        
        table.setLayoutData(data);
        
        table.addMouseListener(this);
        table.addKeyListener(this);
        menu1 = new Menu(table);
        table.setMenu(menu1);
        addfile = new MenuItem(menu1, SWT.PUSH);
        addfile.setText(Messages.getString("FileListTable.addfile")); //$NON-NLS-1$
        addfile.addSelectionListener(this);
        addfolder = new MenuItem(menu1, SWT.PUSH);
        addfolder.setText(Messages.getString("FileListTable.adddir")); //$NON-NLS-1$
        addfolder.addSelectionListener(this);
        separatemenu3 = new MenuItem(menu1, SWT.SEPARATOR);
        deletefile = new MenuItem(menu1, SWT.PUSH);
        deletefile.setText(Messages.getString("FileListTable.delete_selection")); //$NON-NLS-1$
        deletefile.addSelectionListener(this);
        MenuItem item=new MenuItem(menu1,SWT.SEPARATOR);
        item.setText("");//dummy for pmd //$NON-NLS-1$
        deleteAll = new MenuItem(menu1, SWT.PUSH);
        deleteAll.setText(Messages.getString("FileListTable.deleteall")); //$NON-NLS-1$
        deleteAll.addSelectionListener(this);
        
        
        Transfer[] types = new Transfer[] {FileTransfer.getInstance()};
    	
    	int operations = DND.DROP_MOVE | DND.DROP_COPY ;
    	
    	
    		
    	
    	
    	
    	
    		DropTarget target2 = new DropTarget (table, operations);
    		target2.setTransfer(types);
    	
    		target2.addDropListener(new DropMonitor());
    		
    		//setVisibleFilterExtensions(false);
    }

    
    public void widgetSelected(SelectionEvent event) {
        Object target = event.getSource();
        if (target == menu1) {
            do_menu1();
        }
        //    addfile
        else if (target == addfile) {
            execAddFile();
        }
        //    addfolder
        else if (target == addfolder) {
            execAddFolder();
        }
        //    deletefile
        else if (target == deletefile) {
            execDeleteFile();
        }else if (target == deleteAll) {
            execDeleteAll();
        }

    }

    public void widgetDefaultSelected(SelectionEvent arg0) {
        
    }

    //null1
    public void do_menu1() {
        System.out.println("menu1"); //$NON-NLS-1$
    }

    //    addfile
    
    public String[] toFileterExtensions(){
        if(filterExtensionsText.getText().length()>0){
            String lines[]=filterExtensionsText.getText().split(" ");
            return lines;
        }else{
            return filterExtensions;
        }
    }
    
    private String[] filterExtensions;
    
    public static String[] converExtensionsToFilterExtensions(String extension[]){
        if(extension==null){
            return null;
        }else{
            String filter[]=new String[extension.length];
            for (int i = 0; i < filter.length; i++) {
                filter[i]="*."+extension[i];
            }
            return filter;
        }
    }
    public void execAddFile() {
        FileDialog dialog=new FileDialog(table.getShell(),SWT.OPEN);
        
        String fileter[]=toFileterExtensions();
        if(fileter!=null){
           dialog.setFilterExtensions(fileter);
        }
        
        String file=dialog.open();
        if(file!=null){
            addFilePath(file);
        }
    }

    //    addfolder
    public void execAddFolder() {
        DirectoryDialog dialog=new DirectoryDialog(table.getShell(),SWT.OPEN);
        String file=dialog.open();
        if(file!=null){
           addDirectoryPath(file);
        }
    }

    //    deletefile
    public void execDeleteFile() {
        int selection=table.getSelectionIndex();
        if(selection!=-1){
            String path=table.getItem(selection).getText();
            table.remove(selection);
            
            fireRemoveFile(path);
        }
    }
    
    public  void execDeleteAll() {
        int size=table.getItemCount();
        for(int i=size-1;i>=0;i--){
            String path=table.getItem(i).getText();
            table.remove(i);
            
            fireRemoveFile(path);
        }
        
        
    }

    public Table getTable() {
        return table;
    }
    public void setTable(Table table) {
        this.table = table;
    }
    

    public void setFileListText(String text) {
        if(text!=null&&text.length()>0){
            String path[]=text.split(";"); //$NON-NLS-1$
            for(int i=0;i<path.length;i++){
                addDragAndDropFile(path[i]);
            }
        }
    }
    
   
    public String[] getFiles(){
        String result[]=new String[table.getItemCount()];
        for (int i = 0; i < result.length; i++) {
            result[i]=table.getItem(i).getText();
        }
        return result;
    }
   

    /**
     * @return
     */
    public int getFileCount() {
        // TODO Auto-generated method stub
        return table.getItemCount();
    }

    /**
     * @param string
     */
   

    /**
     * @return
     */
    public String getFileListText() {
      String fileList[]=getFiles();
      String result=""; //$NON-NLS-1$
      for (int i = 0; i < fileList.length; i++) {
        result+=fileList[i];
        if(i!=fileList.length-1){
            result+=";"; //$NON-NLS-1$
        }
    }
      return result;
    }

    /**
     * @param path
     */
    
    public WildCard[] getWildCards(){
        String filter[]=toFileterExtensions();
        if(filter!=null){
            return toWildCard(filter);
        }
        else{
            return null;
        }
    }
    public boolean acceptFilePattern(String path){
        String filter[]=toFileterExtensions();
        File f=new File(path);
        if(f.isDirectory()){
            return true; //folder always true.
        }
        if(filter!=null){
            WildCard wildCard[]=toWildCard(filter);
            
            for(int i=0;i<wildCard.length;i++){
                
            if(wildCard[i].match(f.getName())){
            
                if(addsameFile==true || !existPath(path)){
                TableItem item=new TableItem(table,SWT.NULL);
                item.setText(path);
                item.setImage(fileIcon);
                return true;
                }
            }
            }
            return false;
        }else{
            //no pattern return true.
            return true;
        }
    }
    
    protected void addFilePath(String path) {
        
       
       
           
        
        String filter[]=toFileterExtensions();
    if(filter!=null){
        WildCard wildCard[]=toWildCard(filter);
        
        for(int i=0;i<wildCard.length;i++){
            File f=new File(path);
        if(wildCard[i].match(f.getName())){
        
            if(addsameFile==true || !existPath(path)){
            TableItem item=new TableItem(table,SWT.NULL);
            item.setText(path);
            item.setImage(fileIcon);
            break;
            }
        }
        }
        }else{
            if(addsameFile==true || !existPath(path)){
                TableItem item=new TableItem(table,SWT.NULL);
                item.setText(path);
                item.setImage(fileIcon);
                
                }
        }
        fireAddFile(path);
    }
    /**
     * @param path
     * @return
     */
    public boolean existPath(String path) {
        int size=table.getItemCount();
        for (int i = 0; i < size; i++) {
            
            if(table.getItem(i).getText().equals(path)){
                return true;
            }
        }
        return false;
    }



    private WildCard[] toWildCard(String filters[]){
        if(filters==null){
            return null;
        }else{
            WildCard[] wildCard=new WildCard[filters.length];
            for (int i = 0; i < wildCard.length; i++) {
                wildCard[i]=new WildCard(filters[i]);
            }
            return wildCard;
        }
    }

    /**
     * @param path
     */
    protected void addDirectoryPath(String path) {
        TableItem item=new TableItem(table,SWT.NULL);
        item.setText(path);
        item.setImage(folderIcon);
        fireAddFile(path);
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.MouseListener#mouseDoubleClick(org.eclipse.swt.events.MouseEvent)
     */
    public void mouseDoubleClick(MouseEvent arg0) {
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.MouseListener#mouseDown(org.eclipse.swt.events.MouseEvent)
     */
    public void mouseDown(MouseEvent event) {
        if(event.button==1){
            TableItem item=table.getItem(new Point(event.x,event.y));
            if(item==null){
                table.setSelection(-1);
            }
        }
        if(event.button==3){
             if(table.getSelectionIndex()==-1){
                deletefile.setEnabled(false);
            }else{
                deletefile.setEnabled(true);
            }
        }
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
     */
    public void mouseUp(MouseEvent arg0) {
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.KeyListener#keyPressed(org.eclipse.swt.events.KeyEvent)
     */
    public void keyPressed(KeyEvent arg0) {
        // TODO Auto-generated method stub
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.KeyListener#keyReleased(org.eclipse.swt.events.KeyEvent)
     */
    public void keyReleased(KeyEvent event) {
        if(event.keyCode==127){
            execDeleteFile();
        }
       
    }
    
  

    private List fileListChangeListener=new Vector();
    private DropTargetListener monitor=new DropMonitor();

    private Label filterExtensionsLabel;
    
    public synchronized void removeFileListChangeListener(FileStatusChangeListener listener){
     fileListChangeListener.remove(listener);   
    }
    
    public synchronized void addFileListChangeListener(FileStatusChangeListener listener){
        fileListChangeListener.add(listener);   
       }
    
    public void fireRemoveFile(String file){
        
        FileStatusChangeEvent event=new FileStatusChangeEvent(this,file);
        synchronized(this){
            FileStatusChangeListener[] listeners=(FileStatusChangeListener[])fileListChangeListener.toArray(new FileStatusChangeListener[fileListChangeListener.size()]);
            
            for (int i = 0; i < listeners.length; i++) {
                
                listeners[i].removeList(event);
            }
        }
    }
    
    public void fireAddFile(String file){
        FileStatusChangeEvent event=new FileStatusChangeEvent(this,file);
        synchronized(this){
            FileStatusChangeListener[] listeners=(FileStatusChangeListener[])fileListChangeListener.toArray(new FileStatusChangeListener[fileListChangeListener.size()]);
            for (int i = 0; i < listeners.length; i++) {
                listeners[i].addList(event);
            }
        }
    }
    

  
    
    public class DropMonitor extends DropTargetAdapter{
		public void dragEnter(DropTargetEvent event){
			//System.out.println("drag enter:"+event.data);
		}
		public void dragOver(DropTargetEvent event){
			//System.out.println("drag over:"+event.data);
			}
		public void drop(DropTargetEvent event){
			//System.out.println("drop:"+event.data);
			
			//System.out.println(event.data.getClass().getName());
			String files[]=(String[])event.data;
		
		
			for(int i=0;i<files.length;i++){
				addDragAndDropFile(files[i]);
			}
			
			}
	}
    
    
    public void addDragAndDropFile(String path){
        File file=new File(path);
        if(file.isDirectory()){
            addDirectoryPath(path);
        }else{
                 
                    addFilePath(path);
                
           
           
        }
    }

    /**
     * @return
     */
    public DropTargetListener getDropTargetMonitor() {
        // TODO Auto-generated method stub
        return monitor;
    }
    public boolean isEditableExtensions() {
        return editableExtensions;
    }
    public void setEditableExtensions(boolean editableExtensions) {
        this.editableExtensions = editableExtensions;
        filterExtensionsText.setEditable(editableExtensions);
    }
    public String[] getFilterExtensions() {
        return filterExtensions;
    }
    public void setFilterExtensions(String[] filterExtensions) {
        this.filterExtensions = filterExtensions;
    }
}

