/*
 * 쐬: 2003/11/09
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package tmp.org.jpn.xucker.commons.audio.wav;

import java.io.IOException;
import java.io.InputStream;

/**
 * @author akito
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class RiffParser {
	protected int currentRead;
	RiffData rootChunk;
	public RiffData parse(InputStream input) throws RiffParseErrorException{
		if (!RiffUtil.isValidString(input, "RIFF")) {
					throw new RiffParseErrorException("not format 'WAVE'");
				}
		currentRead+=4;
		
		int length=RiffUtil.parseLitteleEndian(input, 4);
		
		currentRead+=4;
		
		String name=RiffUtil.readString(input, 4) ;
		
		currentRead+=4;
		
		rootChunk=new RiffData(name,length);
		parse(rootChunk,input,length-4); //-4 becouse read WAVE string
		return rootChunk;
	}
	
	public long parse(ListChunk chunk,InputStream input, long maxByte) throws RiffParseErrorException {
			long readByte=0;
		String subName=null;
			//System.out.println("current:"+currentRead);
			while(true){
				String name=RiffUtil.readString(input, 4) ;
				readByte+=4;
				currentRead+=4;
				int length=RiffUtil.parseLitteleEndian(input, 4);
				readByte+=4;
				currentRead+=4;
				//System.out.println("parse:"+name+" "+length);
				if(isListChunk(name)){
					subName=RiffUtil.readString(input, 4) ;
					//becouse contain length
					//readByte+=4;
					//currentRead+=4;
					ListChunk newChunk=new ListChunk(subName,length);
					chunk.addChunk(newChunk);
					this.parse(newChunk,input,length-4);
					
				}
				else{
					if(length%2==1){
						try {
							input.skip(1);
							readByte++;
							currentRead++;
						} catch (IOException e) {
							// TODO ꂽ catch ubN
							e.printStackTrace();
						}
					}
					SubChunk newChunk=parseSubChunk(name,length,input);
					chunk.addChunk(newChunk);
				}
			
				readByte+=length;
				currentRead+=length;
				//System.out.println("read="+readByte+" max="+maxByte+" current="+currentRead);
				if(readByte==maxByte){
					break;
				}
				
				if(readByte>maxByte){
					throw new RiffParseErrorException("over sub read="+readByte+"max="+maxByte+" "+name+"/"+subName+"\n"+RiffUtil.toTreeText(rootChunk,""));
				}
			}
			return readByte;
		}
		
   /**
	 * @param name
	 * @return
	 */
	private boolean isListChunk(String name) {
		if(name.equals("LIST")){
			return true;
		}
		return false;
	}

	public SubChunk parseSubChunk(String name,int length,InputStream input) throws RiffParseErrorException {
  	try {
		input.skip(length);
	} catch (IOException e) {
		throw new RiffParseErrorException("subChunkParse:"+name+" faild");
	}
  	return new SubChunk(name,length);
  }
}
