/*
 * 쐬: 2003/10/31
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package tmp.org.jpn.xucker.commons.audio.wav;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;

/**
 * @author akito
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class WavParser extends RiffUtil{

	public static WavData parse(InputStream stream)
		throws RiffParseErrorException {
		BufferedInputStream input = new BufferedInputStream(stream);
		WavData wavData = new WavData();

		if (!isValidString(input, "RIFF")) {
			throw new RiffParseErrorException("not format 'WAVE'");
		}

		wavData.setChunkSize(parseLitteleEndian(input, 4));

		if (!isValidString(input, "WAVE")) {
			throw new RiffParseErrorException("not format 'WAVE'");
		}

		parseSubChunks(input, wavData);
		parseComment(input, wavData);
		//System.out.println("size:"+wavData.getChunkSize());

		try {
			stream.close();
		} catch (IOException e1) {
			// TODO ꂽ catch ubN
			e1.printStackTrace();
		}
		return wavData;
	}

	/**
	 * @param input
	 */
	private static void parseComment(BufferedInputStream input, WavData data) {
		// TODO ꂽ\bhEX^u
		//do nothing.
	}

	/**
	 * @param input
	 */
	private static void parseSubChunks(BufferedInputStream input, WavData data)
		throws RiffParseErrorException {
		while (true) {
			String chunkName = readString(input, 4);
			int chunkSize = parseLitteleEndian(input, 4);
			byte bytes[] = readByte(input, chunkSize);
			if (chunkName.equals("fmt ")) {
				parseFormat(bytes, data);
			} else if (chunkName.equals("data")) {
				parseData(bytes, data);
				return; //probably remain comment.
			} else {
				data.addSubChunk(chunkName, bytes);
			}

		}
	}

	/**
	 * @param bytes
	 */
	private static void parseFormat(byte[] bytes, WavData data)
		throws RiffParseErrorException {
		// TODO ꂽ\bhEX^u
		if (bytes.length < 16) {
			throw new RiffParseErrorException("format length is wrong");
		}
	
		data.setAudioFormat(toNumber(bytes,0,2));

	
		data.setChannel(toNumber(bytes,2,2));

	
		data.setSampleRate(toNumber(bytes,4,4));

		//BytesPerSec
		toNumber(bytes,8,4);

		data.setBlockAlign(toNumber(bytes,12,2));
		data.setSampleBits(toNumber(bytes,14,2));
	}
	
	

	/**
	 * @param bytes
	 */
	private static void parseData(byte[] bytes, WavData data) {
		// TODO ꂽ\bhEX^u
		//System.out.println("data");
		//System.out.println(bytes.length);
		data.setData(bytes);
	}

	

}
